__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >(3cxx)

NAME
__gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >

SYNOPSIS

Inherits Cmp_Fn.

  Public Types

typedef _Alloc allocator_type
typedef Cmp_Fn cmp_fn
typedef left_child_next_sibling_heap_const_iterator_< node, _Alloc > const_iterator
typedef __rebind_v::other::const_pointer const_pointer
typedef __rebind_v::other::const_reference const_reference
typedef _Alloc::difference_type difference_type
typedef const_iterator iterator
typedef left_child_next_sibling_heap_node_point_const_iterator_< node, _Alloc > point_const_iterator
typedef point_const_iterator point_iterator
typedef __rebind_v::other::pointer pointer
typedef __rebind_v::other::reference reference
typedef _Alloc::size_type size_type
typedef Value_Type value_type

  Public Member Functions

left_child_next_sibling_heap (const Cmp_Fn &)
left_child_next_sibling_heap (const left_child_next_sibling_heap &)
iterator begin ()
const_iterator begin () const
void clear ()
bool empty () const
iterator end ()
const_iterator end () const
Cmp_Fn & get_cmp_fn ()
const Cmp_Fn & get_cmp_fn () const
size_type max_size () const
size_type size () const
void swap (left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc > &)

  Protected Types

typedef node_allocator::value_type node
typedef _Alloc::template rebind< left_child_next_sibling_heap_node_< Value_Type, Node_Metadata, _Alloc > >::other node_allocator
typedef node_allocator::const_pointer node_const_pointer
typedef Node_Metadata node_metadata
typedef node_allocator::pointer node_pointer
typedef std::pair< node_pointer, node_pointer > node_pointer_pair

  Protected Member Functions

void actual_erase_node (node_pointer)
void bubble_to_top (node_pointer)
void clear_imp (node_pointer)
node_pointer get_new_node_for_insert (const_reference)
template<typename Pred > node_pointer prune (Pred)
void swap_with_parent (node_pointer, node_pointer)
void to_linked_list ()
void value_swap (left_child_next_sibling_heap &)

  Static Protected Member Functions

static void make_child_of (node_pointer, node_pointer)
static node_pointer parent (node_pointer)

  Protected Attributes

node_pointer m_p_root
size_type m_size

Detailed Description

  template<typename Value_Type, typename Cmp_Fn, typename Node_Metadata, typename _Alloc>
class __gnu_pbds::detail::left_child_next_sibling_heap< Value_Type, Cmp_Fn, Node_Metadata, _Alloc >" Base class for a basic heap.

Definition at line 90 of file left_child_next_sibling_heap_.hpp.

Author

Generated automatically by Doxygen for libstdc++ from the source code.